# Minerva
Minerva is an educational project that lets you learn advanced data science on real-life, curated problems.

---

# Getting started
1. Follow the [Installation Guide](https://github.com/neptune-ml/minerva/wiki/Installation-Guide 'Minerva Wiki -> installation guide') for setup instructions.
2. Familiarize yourself with our approach: check [User Guide](https://github.com/neptune-ml/minerva/wiki/User-Guide 'Minerva Wiki -> User Guide') or go straight to the [Fashion MNIST problem](resources/fashion_mnist/tasks/hello-fashion_mnist.ipynb 'Fashion MNIST -> Welcome notebook') and start solving.
3. When ready, go to [Right Whale Recognition problem](resources/whales/tasks/hello-whales.ipynb 'Right Whale Recognition -> Welcome notebook') to start working on complex problem.

---

## Hands-on approach to learning
With Minerva you will reproduce, piece by piece, a solution to the most difficult data scientific problems, especially challenges. Since each **problem** is quite complex, we divided it into a collection of small self-contained pieces called **tasks**.

**Task** is a single step in machine learning pipeline, it has its own learning objectives, descriptions and a piece of code that needs to be implemented. This is your job: to create a technical implementation that fulfills this gap. You use your engineering skills, extensive experimentation and our feedback in order to make sure that your implementation meets certain quality level. We know what the final score for a well implemented pipeline should be. So as you solve tasks and re-implement parts of the pipeline we will be checking whether your implementation does the job well enough to keep the score high.

## Reproduce Kaggle winning solutions in a transparent way &rarr; learn advanced data science
Working on **tasks** that, if taken together, create solution to the **problem** lets you reproduce Kaggle winning solution, piece by piece. This is our hands on approach to learning, because you can work on each part of the winning implementation by yourself.

## Available problems

| Problem        | Description   |
| -------------- | ------------- |
| [Fashion mnist](https://github.com/neptune-ml/minerva/blob/master/resources/fashion_mnist/tasks/hello-fashion_mnist.ipynb)  | Get started with Minerva by solving easy pipeline on nice dataset [fashion-mnist](https://github.com/zalandoresearch/fashion-mnist 'Fashion-MNIST dataset') |
| [Whales](https://github.com/neptune-ml/minerva/blob/master/resources/whales/tasks/hello-whales.ipynb)         | Reproduce [Right Whale Recognition](https://www.kaggle.com/c/noaa-right-whale-recognition 'Right Whale Recognition') Kaggle winning solution! |
| | *(more problems will be published in the future, so stay tuned)* |

## Disclaimer
In this open source solution you will find references to the neptune.ml. It is free platform for community Users, which we use daily to keep track of our experiments. Please note that using neptune.ml is not necessary to proceed with this solution. You may run it as plain Python script :wink:.

## User support
You can seek support in two ways:

1. Check [Minerva wiki](https://github.com/neptune-ml/minerva/wiki 'Minerva wiki') for typical problems and questions.
2. Create an issue with label `question`, in case [Minerva wiki](https://github.com/neptune-ml/minerva/wiki 'Minerva wiki') does not have an answer to your question.

## Contributing to Minerva
Check [CONTRIBUTING](CONTRIBUTING.md) for more information.

## About the name
Minerva is a Roman goddess of wisdom, arts and craft. She was usually presented with the strong association with knowledge. Her sacred creature *'owl of Minerva'* symbolizes wisdom and knowledge. We think that this name depicts our project very well, since it is about acquiring knowledge and skills.
